/* Routines that generate the 3d figs for the Vanderbit 2003 paper. */
/* Last edited on 2007-01-04 00:13:02 by stolfi */

#ifndef figs3d_H
#define figs3d_H

#include <stdio.h>
#include <ps.h>

#include <dg_grid.h>
#include <dg_tree.h>

#include <figtools.h>

void figs_3d_full
  ( PlotOptions *o, 
    char *tag,
    interval_t rootCell[], 
    dg_rank_t max_rank
  );
  /* Outputs several figures showing some levels {0..maxRank} of the
    infinite 3D dyadic hierarchy with given {rootCell}. */

void fig_3d_full_level
  ( PlotOptions *o, 
    char *tag, 
    interval_t rootCell[], 
    dg_rank_t rank
  );
  /* Outputs a figure showing level {rank} of the infinite 3D dyadic
    hierarchy. */

void plot_3d_cell
  ( PSStream *ps,
    PlotOptions *o,
    interval_t cell[], 
    double blow,
    double vdist
  );
  /* Plots the given 3D {cell} in perspective. The cell is shrunk by
    {1/blow} towards its center, to produce the "blow-up" effect.
    uses {persp_project} to project the corners. */

#endif
